package fr.irisa.cairn.jnimap.polylib;

import java.util.AbstractMap;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import fr.irisa.cairn.jnimap.runtime.JNIObject;


/*** PROTECTED REGION ID(PolyLibPolyhedron_userImport) ENABLED START ***/
	/*
		Put you custom import here ....
	*/
/*** PROTECTED REGION END ***/

/**
 *  Automatically generated by jnimap 
 * @generated
 */
public class PolyLibPolyhedron extends JNIObject  {
	
	
	/* @generated */
	protected PolyLibPolyhedron(long ptr) {
		/*** PROTECTED REGION ID(PolyLibPolyhedron_Constructor) DISABLED START ***/
		super(ptr);
		/*** PROTECTED REGION END ***/
	}
	
	
	/* @generated */
	static PolyLibPolyhedron build(long ptr) {
		{
			return new PolyLibPolyhedron(ptr);
		}
	}
	
	
	
	
	/***PROTECTED REGION ID(PolyLibPolyhedron_userCode) ENABLED START***/
	public static PolyLibPolyhedron createFromLongMatrix(long[][] t) {
		PolyLibMatrix mat = PolyLibMatrix.allocate(t.length,  t[0].length);
		for (int i = 0; i < t.length; i++) {
			for (int j = 0; j < t[0].length; j++) {
				mat.setAt(i, j, t[i][j]);
			}
		}
		
		//FIXME nbMaxRay is hard coded
		return PolyLibPolyhedron.buildFromConstraints(mat, 9);
	}
	/***PROTECTED REGION END***/

	/*************************************** 
	 *	     Struct Field Accessors        * 
	 ***************************************/
	/*************************************************************
	 *	Dimension : int
	 *************************************************************/
	public int getDimension() {
		return PolylibNative.polyhedron_get_Dimension(getNativePtr(this));
	}
	/*************************************************************
	 *	Dimension : int
	 *************************************************************/
	public void setDimension(int object) {
		PolylibNative.polyhedron_set_Dimension(getNativePtr(this), object);
	}
	/*************************************************************
	 * Test if TDimension is NULL
	 *************************************************************/
	public boolean testDimension() {
		return PolylibNative.polyhedron_test_Dimension(getNativePtr(this)) != 0;
	}
	/*************************************************************
	 *	NbConstraints : int
	 *************************************************************/
	public int getNbConstraints() {
		return PolylibNative.polyhedron_get_NbConstraints(getNativePtr(this));
	}
	/*************************************************************
	 *	NbConstraints : int
	 *************************************************************/
	public void setNbConstraints(int object) {
		PolylibNative.polyhedron_set_NbConstraints(getNativePtr(this), object);
	}
	/*************************************************************
	 * Test if TNbConstraints is NULL
	 *************************************************************/
	public boolean testNbConstraints() {
		return PolylibNative.polyhedron_test_NbConstraints(getNativePtr(this)) != 0;
	}
	/*************************************************************
	 *	NbRays : int
	 *************************************************************/
	public int getNbRays() {
		return PolylibNative.polyhedron_get_NbRays(getNativePtr(this));
	}
	/*************************************************************
	 *	NbRays : int
	 *************************************************************/
	public void setNbRays(int object) {
		PolylibNative.polyhedron_set_NbRays(getNativePtr(this), object);
	}
	/*************************************************************
	 * Test if TNbRays is NULL
	 *************************************************************/
	public boolean testNbRays() {
		return PolylibNative.polyhedron_test_NbRays(getNativePtr(this)) != 0;
	}
	/*************************************************************
	 *	NbEq : int
	 *************************************************************/
	public int getNbEq() {
		return PolylibNative.polyhedron_get_NbEq(getNativePtr(this));
	}
	/*************************************************************
	 *	NbEq : int
	 *************************************************************/
	public void setNbEq(int object) {
		PolylibNative.polyhedron_set_NbEq(getNativePtr(this), object);
	}
	/*************************************************************
	 * Test if TNbEq is NULL
	 *************************************************************/
	public boolean testNbEq() {
		return PolylibNative.polyhedron_test_NbEq(getNativePtr(this)) != 0;
	}
	/*************************************************************
	 *	NbBid : int
	 *************************************************************/
	public int getNbBid() {
		return PolylibNative.polyhedron_get_NbBid(getNativePtr(this));
	}
	/*************************************************************
	 *	NbBid : int
	 *************************************************************/
	public void setNbBid(int object) {
		PolylibNative.polyhedron_set_NbBid(getNativePtr(this), object);
	}
	/*************************************************************
	 * Test if TNbBid is NULL
	 *************************************************************/
	public boolean testNbBid() {
		return PolylibNative.polyhedron_test_NbBid(getNativePtr(this)) != 0;
	}
	
	/*************************************** 
	 *	         Static Methods            * 
	 ***************************************/
	/**
	 * Empty_Polyhedron 
	 * 
	 * @generated
	**/
	 public static PolyLibPolyhedron allocateEmpty(int Dimension) { 
		/*** PROTECTED REGION ID(static_Empty_Polyhedron) DISABLED START ***/
		PolyLibPolyhedron res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = PolyLibPolyhedron.build(PolylibNative.Empty_Polyhedron(Dimension));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * Polyhedron_Alloc 
	 * 
	 * @generated
	**/
	 public static PolyLibPolyhedron allocate(int Dimension, int NbConstraints, int NbRays) { 
		/*** PROTECTED REGION ID(static_Polyhedron_Alloc) DISABLED START ***/
		PolyLibPolyhedron res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = PolyLibPolyhedron.build(PolylibNative.Polyhedron_Alloc(Dimension, NbConstraints, NbRays));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * Constraints2Polyhedron 
	 * 
	 * @generated
	**/
	 public static PolyLibPolyhedron buildFromConstraints(PolyLibMatrix Constraints, int NbMaxRays) { 
		/*** PROTECTED REGION ID(static_Constraints2Polyhedron) DISABLED START ***/
		PolyLibPolyhedron res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = PolyLibPolyhedron.build(PolylibNative.Constraints2Polyhedron(getNativePtr(Constraints), NbMaxRays));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * Rays2Polyhedron 
	 * 
	 * @generated
	**/
	 public static PolyLibPolyhedron buildFromRaysVertices(PolyLibMatrix Ray, int NbMaxConstrs) { 
		/*** PROTECTED REGION ID(static_Rays2Polyhedron) DISABLED START ***/
		PolyLibPolyhedron res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = PolyLibPolyhedron.build(PolylibNative.Rays2Polyhedron(getNativePtr(Ray), NbMaxConstrs));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * Universe_Polyhedron 
	 * 
	 * @generated
	**/
	 public static PolyLibPolyhedron buildUniversePolyedron(int Dimension) { 
		/*** PROTECTED REGION ID(static_Universe_Polyhedron) DISABLED START ***/
		PolyLibPolyhedron res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = PolyLibPolyhedron.build(PolylibNative.Universe_Polyhedron(Dimension));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * DomainDifference 
	 * 
	 * @generated
	**/
	 public static PolyLibPolyhedron difference(PolyLibPolyhedron Pol1, PolyLibPolyhedron Pol2, int NbMaxRays) { 
		/*** PROTECTED REGION ID(static_DomainDifference) DISABLED START ***/
		PolyLibPolyhedron res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = PolyLibPolyhedron.build(PolylibNative.DomainDifference(getNativePtr(Pol1), getNativePtr(Pol2), NbMaxRays));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * DomainIntersection 
	 * 
	 * @generated
	**/
	 public static PolyLibPolyhedron intersection(PolyLibPolyhedron Pol1, PolyLibPolyhedron Pol2, int NbMaxRays) { 
		/*** PROTECTED REGION ID(static_DomainIntersection) DISABLED START ***/
		PolyLibPolyhedron res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = PolyLibPolyhedron.build(PolylibNative.DomainIntersection(getNativePtr(Pol1), getNativePtr(Pol2), NbMaxRays));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	/*************************************** 
	 *	         Member Methods            * 
	 ***************************************/
	/**
	 * DomainSimplify 
	 * 
	 * @generated
	**/
	public PolyLibPolyhedron simplify(PolyLibPolyhedron Pol2, int NbMaxRays) {
		/*** PROTECTED REGION ID(DomainSimplify) DISABLED START ***/
		PolyLibPolyhedron res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = PolyLibPolyhedron.build(PolylibNative.DomainSimplify(getNativePtr(this), getNativePtr(Pol2), NbMaxRays));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * DomainConstraintSimplify 
	 * 
	 * @generated
	**/
	public PolyLibPolyhedron simplify(int MaxRays) {
		/*** PROTECTED REGION ID(DomainConstraintSimplify) DISABLED START ***/
		PolyLibPolyhedron res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = PolyLibPolyhedron.build(PolylibNative.DomainConstraintSimplify(getNativePtr(this), MaxRays));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * AddPolyToDomain 
	 * 
	 * @generated
	**/
	public PolyLibPolyhedron addPolyToDomain(PolyLibPolyhedron PolDomain) {
		/*** PROTECTED REGION ID(AddPolyToDomain) DISABLED START ***/
		PolyLibPolyhedron res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = PolyLibPolyhedron.build(PolylibNative.AddPolyToDomain(getNativePtr(this), getNativePtr(PolDomain)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * align_context 
	 * 
	 * @generated
	**/
	public PolyLibPolyhedron alignContext(int align_dimension, int NbMaxRays) {
		/*** PROTECTED REGION ID(align_context) DISABLED START ***/
		PolyLibPolyhedron res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = PolyLibPolyhedron.build(PolylibNative.align_context(getNativePtr(this), align_dimension, NbMaxRays));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * Disjoint_Domain 
	 * 
	 * @generated
	**/
	public PolyLibPolyhedron disjointDomain(int flag, int NbMaxRays) {
		/*** PROTECTED REGION ID(Disjoint_Domain) DISABLED START ***/
		PolyLibPolyhedron res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = PolyLibPolyhedron.build(PolylibNative.Disjoint_Domain(getNativePtr(this), flag, NbMaxRays));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * Stras_DomainSimplify 
	 * 
	 * @generated
	**/
	public PolyLibPolyhedron strasSimplify(PolyLibPolyhedron Pol2, int NbMaxRays) {
		/*** PROTECTED REGION ID(Stras_DomainSimplify) DISABLED START ***/
		PolyLibPolyhedron res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = PolyLibPolyhedron.build(PolylibNative.Stras_DomainSimplify(getNativePtr(this), getNativePtr(Pol2), NbMaxRays));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * Polyhedron2Rays 
	 * 
	 * @generated
	**/
	public PolyLibMatrix builRaysVertices() {
		/*** PROTECTED REGION ID(Polyhedron2Rays) DISABLED START ***/
		PolyLibMatrix res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = PolyLibMatrix.build(PolylibNative.Polyhedron2Rays(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * PolyhedronIncludes 
	 * 
	 * @generated
	**/
	public int includes(PolyLibPolyhedron Pol2) {
		/*** PROTECTED REGION ID(PolyhedronIncludes) DISABLED START ***/
		int res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = PolylibNative.PolyhedronIncludes(getNativePtr(this), getNativePtr(Pol2));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * Polyhedron_Copy 
	 * 
	 * @generated
	**/
	public PolyLibPolyhedron copy() {
		/*** PROTECTED REGION ID(Polyhedron_Copy) DISABLED START ***/
		PolyLibPolyhedron res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = PolyLibPolyhedron.build(PolylibNative.Polyhedron_Copy(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * Polyhedron_Free 
	 * 
	 * @generated
	**/
	public void free() {
		/*** PROTECTED REGION ID(Polyhedron_Free) DISABLED START ***/
		
		synchronized(LOCK) {
			checkParameters();
			try {
				PolylibNative.Polyhedron_Free(getNativePtr(this));
			} finally {
			}
		}
		
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * Polyhedron_Image 
	 * 
	 * @generated
	**/
	public PolyLibPolyhedron image(PolyLibMatrix Func, int NbMaxConstrs) {
		/*** PROTECTED REGION ID(Polyhedron_Image) DISABLED START ***/
		PolyLibPolyhedron res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = PolyLibPolyhedron.build(PolylibNative.Polyhedron_Image(getNativePtr(this), getNativePtr(Func), NbMaxConstrs));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * Polyhedron_Preimage 
	 * 
	 * @generated
	**/
	public PolyLibPolyhedron preimage(PolyLibMatrix Func, int NbMaxRays) {
		/*** PROTECTED REGION ID(Polyhedron_Preimage) DISABLED START ***/
		PolyLibPolyhedron res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = PolyLibPolyhedron.build(PolylibNative.Polyhedron_Preimage(getNativePtr(this), getNativePtr(Func), NbMaxRays));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * Polyhedron_Scan 
	 * 
	 * @generated
	**/
	public PolyLibPolyhedron scan(PolyLibPolyhedron C, int MAXRAYS) {
		/*** PROTECTED REGION ID(Polyhedron_Scan) DISABLED START ***/
		PolyLibPolyhedron res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = PolyLibPolyhedron.build(PolylibNative.Polyhedron_Scan(getNativePtr(this), getNativePtr(C), MAXRAYS));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * PolyPrint 
	 * 
	 * @generated
	**/
	public void print() {
		/*** PROTECTED REGION ID(PolyPrint) DISABLED START ***/
		
		synchronized(LOCK) {
			checkParameters();
			try {
				PolylibNative.PolyPrint(getNativePtr(this));
			} finally {
			}
		}
		
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * Domain_Free 
	 * 
	 * @generated
	**/
	public void domainFree() {
		/*** PROTECTED REGION ID(Domain_Free) DISABLED START ***/
		
		synchronized(LOCK) {
			checkParameters();
			try {
				PolylibNative.Domain_Free(getNativePtr(this));
			} finally {
			}
		}
		
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * DomainUnion 
	 * 
	 * @generated
	**/
	public PolyLibPolyhedron domainUnion(PolyLibPolyhedron Pol2, int NbMaxRays) {
		/*** PROTECTED REGION ID(DomainUnion) DISABLED START ***/
		PolyLibPolyhedron res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = PolyLibPolyhedron.build(PolylibNative.DomainUnion(getNativePtr(this), getNativePtr(Pol2), NbMaxRays));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * Domain_Copy 
	 * 
	 * @generated
	**/
	public PolyLibPolyhedron domainCopy() {
		/*** PROTECTED REGION ID(Domain_Copy) DISABLED START ***/
		PolyLibPolyhedron res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = PolyLibPolyhedron.build(PolylibNative.Domain_Copy(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * DomainAddConstraints 
	 * 
	 * @generated
	**/
	public PolyLibPolyhedron domainAddConstraints(PolyLibMatrix Mat, int NbMaxRays) {
		/*** PROTECTED REGION ID(DomainAddConstraints) DISABLED START ***/
		PolyLibPolyhedron res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = PolyLibPolyhedron.build(PolylibNative.DomainAddConstraints(getNativePtr(this), getNativePtr(Mat), NbMaxRays));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * DomainAddRays 
	 * 
	 * @generated
	**/
	public PolyLibPolyhedron domainAddRays(PolyLibMatrix Ray, int NbMaxConstrs) {
		/*** PROTECTED REGION ID(DomainAddRays) DISABLED START ***/
		PolyLibPolyhedron res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = PolyLibPolyhedron.build(PolylibNative.DomainAddRays(getNativePtr(this), getNativePtr(Ray), NbMaxConstrs));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * DomainConvex 
	 * 
	 * @generated
	**/
	public PolyLibPolyhedron domainConvex(int NbMaxConstrs) {
		/*** PROTECTED REGION ID(DomainConvex) DISABLED START ***/
		PolyLibPolyhedron res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = PolyLibPolyhedron.build(PolylibNative.DomainConvex(getNativePtr(this), NbMaxConstrs));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	public String toString() {
		/*** PROTECTED REGION ID(PolyLibPolyhedron_toString) DISABLED START ***/
			return PolylibPrettyPrinter.asString(this);
		/*** PROTECTED REGION END ***/
	}
}
